VERSION 5.00
Begin VB.Form frmViewer 
   Caption         =   "Form1"
   ClientHeight    =   3480
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   8580
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3480
   ScaleWidth      =   8580
   Begin VB.PictureBox Picture1 
      Align           =   3  'Align Left
      BorderStyle     =   0  'None
      Height          =   3480
      Left            =   0
      ScaleHeight     =   3480
      ScaleWidth      =   1695
      TabIndex        =   1
      Top             =   0
      Width           =   1695
      Begin VB.FileListBox FileList 
         Height          =   1650
         Left            =   0
         TabIndex        =   5
         Top             =   1440
         Width           =   1575
      End
      Begin VB.DirListBox DirList 
         Height          =   990
         Left            =   0
         TabIndex        =   4
         Top             =   360
         Width           =   1575
      End
      Begin VB.DriveListBox DriveList 
         Height          =   315
         Left            =   0
         TabIndex        =   3
         Top             =   0
         Width           =   1575
      End
      Begin VB.ComboBox PatternCombo 
         Height          =   315
         Left            =   0
         TabIndex        =   2
         Text            =   "Combo1"
         Top             =   3120
         Width           =   1575
      End
   End
   Begin Viewer.Eyes Eyes1 
      Height          =   255
      Left            =   5640
      TabIndex        =   0
      Top             =   240
      Width           =   855
      _ExtentX        =   1508
      _ExtentY        =   450
      Interval        =   200
   End
   Begin VB.Image Image1 
      Height          =   225
      Left            =   1800
      Picture         =   "Form1.frx":0000
      Top             =   960
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Image FileImage 
      Height          =   735
      Left            =   3120
      Top             =   480
      Width           =   855
   End
End
Attribute VB_Name = "frmViewer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim fName As String
Dim mMaximize As Boolean
'----------------------------------------------------------
' Windows api functions
'----------------------------------------------------------
#If UNICODE Then
    Private Declare Function SendMessage Lib "user32" Alias "SendMessageW" (ByVal hwnd As Long, ByVal uMgs As Long, ByVal wParam As Long, lParam As Any) As Long
#Else
    Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal uMgs As Long, ByVal wParam As Long, lParam As Any) As Long
#End If
Private Declare Function ReleaseCapture Lib "user32" () As Long

Private Sub DirList_Change()
    FileList.Path = DirList.Path
End Sub

Private Sub DirList_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Picture1.MousePointer = vbDefault
End Sub

Private Sub DriveList_Change()
    'On Error GoTo DriveError
    DirList.Path = DriveList.Drive
    Exit Sub

DriveError:
    DriveList.Drive = DirList.Path
    Exit Sub
End Sub


' Toggle whether we enlarge small pictures.
Private Sub FileImage_Click()
    mMaximize = Not mMaximize
    LoadFile
End Sub

' Load the selected file.
Private Sub FileList_Click()
    fName = FileList.Path + "\" + FileList.FileName

    MousePointer = vbHourglass
    DoEvents
    LoadFile
    MousePointer = vbDefault
End Sub
' Load the file, shrinking it if necessary
' to make it fit.
Private Sub LoadFile()
    On Error GoTo LoadPictureError

    Dim multiplierX As Single
    Dim multiplierY As Single
    Dim nHeight As Single
    Dim nWidth As Single

    ' Work with the Image control.
    With FileImage
        .Visible = False
        .Stretch = False
        .Picture = LoadPicture(fName)
        Caption = "Viewer [" & fName & " " & .Width / Screen.TwipsPerPixelX & "x" & .Height / Screen.TwipsPerPixelY & "] "

        ' Make the picture fit.
        nWidth = Me.ScaleWidth - Me.ScaleLeft - Picture1.Width
        nHeight = Me.ScaleHeight - Me.ScaleTop

        multiplierX = nWidth / .Width
        multiplierY = nHeight / .Height

        If multiplierX < 1 Or multiplierY < 1 Or mMaximize Then
            .Stretch = True
            If multiplierX < multiplierY Then
                .Width = .Width * multiplierX
                .Height = .Height * multiplierX
            Else
                .Width = .Width * multiplierY
                .Height = .Height * multiplierY
            End If
        End If

        .Left = Me.ScaleLeft + Picture1.Width + ((nWidth - .Width) / 2)
        .Top = Me.ScaleTop + ((nHeight - .Height) / 2)

        .Visible = True
    End With
    Exit Sub

LoadPictureError:
    Beep
    MousePointer = vbDefault
    Caption = "Viewer [Invalid picture]"
    Exit Sub
End Sub
Private Sub FileList_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Picture1.MousePointer = vbDefault
End Sub

' Toggle whether we enlarge small pictures.
Private Sub Form_Click()
    mMaximize = Not mMaximize
    LoadFile
End Sub

Private Sub Form_Load()
    PatternCombo.AddItem "Bitmaps (*.bmp)"
    PatternCombo.AddItem "GIF (*.gif)"
    PatternCombo.AddItem "JPEG (*.jpg)"
    PatternCombo.AddItem "Icons (*.ico)"
    PatternCombo.AddItem "Matafiles (*.wmf)"
    PatternCombo.AddItem "DIBs (*.dib)"
    PatternCombo.AddItem "Graphic (*.gif;*.jpg;*.ico;*.bmp;*.wmf;*.dib)"
    PatternCombo.AddItem "All Files (*.*)"
    PatternCombo.ListIndex = PatternCombo.ListCount - 1
    
     ' Me.Icon = Image1.Picture

End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Picture1.MousePointer = vbDefault
End Sub

Private Sub Form_Resize()
    'Eyes1.Move ScaleWidth - Eyes1.Width, ScaleHeight - Eyes1.Height
    Picture1_Resize
End Sub


' Toggle whether we enlarge small pictures.
Private Sub Image1_Click()
    mMaximize = Not mMaximize
    LoadFile
End Sub

Private Sub PatternCombo_Click()
Dim pat As String
Dim p1 As Integer
Dim p2 As Integer

    pat = PatternCombo.List(PatternCombo.ListIndex)
    p1 = InStr(pat, "(")
    p2 = InStr(pat, ")")
    FileList.Pattern = Mid$(pat, p1 + 1, p2 - p1 - 1)
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ReleaseCapture 'need to do this or SendMessage fails
    SendMessage Picture1.hwnd, &HA1, 11, ByVal &O0
End Sub

Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If X > Picture1.ScaleWidth - 60 Then
    Picture1.MousePointer = vbSizeWE
  Else
    Picture1.MousePointer = vbDefault
  End If
End Sub

Private Sub Picture1_Resize()
  If WindowState = vbMinimized Then Exit Sub
  On Error GoTo eh
    
    Const GAP = 60
    Dim wid As Integer
    Dim hgt As Integer

    Static mbusy As Boolean
    If mbusy Then Exit Sub
    mbusy = True
    
    With Picture1
          If .Width < 3 * GAP Then .Width = 3 * GAP

          wid = .ScaleWidth - 2 * GAP
          
          DriveList.Move GAP, GAP, wid
          PatternCombo.Move GAP, .ScaleHeight - PatternCombo.Height, wid
          
          hgt = (PatternCombo.Top - DriveList.Top - DriveList.Height - 3 * GAP) / 2
          If hgt < 100 Then hgt = 100
          DirList.Move GAP, DriveList.Top + DriveList.Height + GAP, wid, hgt
          FileList.Move GAP, DirList.Top + DirList.Height + GAP, wid, hgt
          LoadFile
          
          Eyes1.Left = ScaleLeft + .Width
          Eyes1.Top = ScaleTop
    End With

eh:

 mbusy = False
End Sub
